<?php

/**
 * @file
 * API documentation for the Entitlements module.
 */

/**
 * @defgroup entitlements_hooks Entitlements hooks
 * @{
 * Hooks that can be implemented by other modules in order to implement the
 * Entitlements API.
 */

/**
 * Register Entitlements provider information.
 *
 * @return
 *   An array with the following possible keys:
 *   - description: (required) A short description to identify this provider.
 *   - class: (required) The class name implementing this provider.
 */
function hook_entitlements_provider_info() {
  return array(
    'provider' => array(
      'description' => t('A short description.'),
      'class' => 'EntitlementsExampleProvider',
    )
  );
}

/**
 * Register Entitlements consumer information.
 *
 * @return
 *   An array with the following possible keys:
 *   - description: A short description to identify this consumer.
 *   - class: (required) The class name implementing this consumer.
 */
function hook_entitlements_consumer_info() {
  return array(
    'consumer' => array(
      'description' => t('A short description.'),
      'class' => 'EntitlementsExampleConsumer',
    )
  );
}

/**
 * @}
 */
