<?php

/**
 * @file
 * User page callbacks for the Entitlements module.
 */

/**
 * Show a list of entitlements for an account.
 *
 * @param $account
 *   (optional) The account to show.
 */
function entitlements_user_profile($account) {
  $entitlements = Entitlements::getEntitlements($account);

  $rows = array();
  foreach ($entitlements as $entitlement) {
    $rows[] = (array) $entitlement;
  }

  return theme('table', array(
    'header' => array(t('Provider'), t('Realm'), t('Name')),
    'rows' => $rows,
    'empty' => t('No entitlements assigned.'),
  ));
}
