<?php

/**
 * @file
 * Contains administrative functions for the Entitlements basic provider module.
 */

/**
 * Form to add new entitlements.
 */
function basic_entitlement_form($form, &$form_state, $entitlement = NULL) {
  if ($entitlement == NULL) {
    $entitlement = entity_get_controller('basic_entitlement')->create();
  }

  $form['name'] = array(
    '#type' => 'textfield',
    '#title' => t('Name'),
    '#required' => TRUE,
    '#default_value' => $entitlement->name,
  );

  $form['realm'] = array(
    '#type' => 'textfield',
    '#title' => t('Realm'),
    '#required' => TRUE,
    '#default_value' => $entitlement->realm,
  );

  $form['description'] = array(
    '#type' => 'textarea',
    '#title' => t('Description'),
    '#required' => TRUE,
    '#default_value' => $entitlement->description,
  );

  $form['basic_entitlement'] = array(
    '#type' => 'value',
    '#value' => $entitlement,
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
    '#weight' => 100,
  );

  return $form;
}

function basic_entitlement_form_submit($form, &$form_state) {
  $entity = $form_state['values']['basic_entitlement'];
  $entity->name = $form_state['values']['name'];
  $entity->realm = $form_state['values']['realm'];
  $entity->description = $form_state['values']['description'];
  entity_get_controller('basic_entitlement')->save($entity);
  drupal_set_message(t('Saved %entitlement.', array('%entitlement' => entity_label('basic_entitlement', $entity))));
  $form_state['redirect'] = 'admin/config/people/entitlements-basic/manage';
}
