<?php

/**
 * @file
 * Contains EntitlementsBasicProvider.
 */

/**
 * Defines a basic Entitlements provider.
 */
class EntitlementsBasicProvider implements EntitlementsProviderInterface {

  /**
   * Implements EntitlementsProviderInterface::listRealms().
   */
  public function listRealms() {
    return db_select('entitlements_basic_provider', 'ebp')
      ->fields('ebp', array('realm'))
      ->distinct()
      ->execute()
      ->fetchCol();
  }

  /**
   * Implements EntitlementsProviderInterface::listEntitlements().
   */
  public function listEntitlements($realm = '') {
    $q = db_select('entitlements_basic_provider', 'ebp')
      ->fields('ebp', array('name'));

    if ($realm != '') {
      $q->condition('realm', $realm);
    }

    return $q->execute()->fetchCol();
  }

}
