<?php

/**
 * @file
 * Contains EntitlementsBasicProviderEntitlementController.
 */

/**
 * Defines a basic entitlement entity controller.
 */
class EntitlementsBasicProviderEntitlementController extends EntityAPIController {

  /**
   * Create and return a new entity_example_basic entity.
   */
  public function create(array $values = array()) {
    $entity = parent::create($values);
    $entity->eid = 0;
    $entity->name = '';
    $entity->realm = '';
    $entity->description = '';
    return $entity;
  }

  /**
   * Saves the custom fields using drupal_write_record()
   */
  public function save($entity) {
    $primary_keys = $entity->eid ? 'eid' : array();
    drupal_write_record('entitlements_basic_provider', $entity, $primary_keys);
    return $entity;
  }

  /**
   * Delete a single entity.
   *
   * Really a convenience function for delete_multiple().
   */
  public function delete($entity) {
    $this->delete_multiple(array($entity));
  }

  /**
   * Delete one or more entity_example_basic entities.
   *
   * Deletion is unfortunately not supported in the base
   * DrupalDefaultEntityController class.
   *
   * @param $basic_ids
   *   An array of entity IDs or a single numeric ID.
   */
  public function delete_multiple($entities) {
    $eids = array();
    if (!empty($entities)) {
      $transaction = db_transaction();
      try {
        foreach ($entities as $entity) {
          $eids[] = $entity[0];
        }
        db_delete('entitlements_basic_provider')
          ->condition('eid', $eids, 'IN')
          ->execute();
      }
      catch (Exception $e) {
        $transaction->rollback();
        watchdog_exception('entitlements_basic_provider', $e);
        throw $e;
      }
    }
  }
}
