<?php

/**
 * @file
 * Contains EntitlementsProviderInterface.
 */

/**
 * Defines the common interface for all Entitlements provider classes.
 */
interface EntitlementsProviderInterface {

  /**
   * List all realms available through this provider.
   *
   * @return
   *   An array of realm names.
   */
  public function listRealms();

  /**
   * List all entitlements available through this provider.
   * (This may or may not be defined by some implementations.)
   *
   * @param $realm
   *   Optionally specify an entitlement realm to search within.
   *
   * @return
   *   An array of entitlements, optionally in a given realm.
   */
  public function listEntitlements($realm = '');

}
