<?php

/**
 * @file
 * Contains EntitlementsRolesConsumer.
 */

/**
 * Defines the common interface for all Entitlements consumer classes.
 */
class EntitlementsRolesConsumer implements EntitlementsConsumerInterface {

  protected $name = 'roles_consumer';

  /**
   * Implements EntitlementsConsumerInterface::addEntitlement().
   */
  public function addEntitlement($account, $provider, $realm, $name) {
    $config = db_select('entitlements_consumers', 'ec')
      ->fields('ec', array('config'))
      ->condition('provider', $provider)
      ->condition('realm', $realm)
      ->condition('name', $name)
      ->condition('consumer', $this->name)
      ->execute()
      ->fetchField();

    if ($config != FALSE) {
      $config = unserialize($config);
      foreach ($config as $role) {
        $role = user_role_load_by_name($role);
        user_multiple_role_edit(array($account->uid), 'add_role', $role->rid);
      }
    }
  }

  /**
   * Implements EntitlementsConsumerInterface::removeEntitlement().
   */
  public function removeEntitlement($account, $provider, $realm, $name) {
    $config = db_select('entitlements_consumers', 'ec')
      ->fields('ec', array('config'))
      ->condition('provider', $provider)
      ->condition('realm', $realm)
      ->condition('name', $name)
      ->condition('consumer', $this->name)
      ->execute()
      ->fetchField();

    if ($config != FALSE) {
      $config = unserialize($config);
      foreach ($config as $role) {
        $role = user_role_load_by_name($role);
        user_multiple_role_edit(array($account->uid), 'remove_role', $role->rid);
      }
    }
  }

}
